﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace MergeCommandBars
{
    public partial class ChildForm : Form
    {
        public ChildForm()
        {
            InitializeComponent();
        }
        FormWindowState previousState = FormWindowState.Normal;

        private void ChildForm_SizeChanged(object sender, EventArgs e)
        {
            if (this.WindowState == FormWindowState.Maximized && this.WindowState!= this.previousState)
            {
                MergeCommandBars();
                this.previousState = FormWindowState.Maximized;
            }
            else if (this.WindowState == FormWindowState.Normal && this.WindowState != this.previousState)
            {
                UnmergeCommandBars();
                this.previousState = FormWindowState.Normal;
            }
        }

        void MergeCommandBars()
        {
            MainForm mainForm = this.MdiParent as MainForm;
            if (mainForm != null)
            {
                if (mainForm.radCommandBar1.Rows.Count == 0)
                {
                    mainForm.radCommandBar1.Rows.Add(new CommandBarRowElement());
                }

                foreach (CommandBarRowElement row in this.radCommandBar1.Rows)
                {
                    foreach (CommandBarStripElement strip in row.Strips)
                    {
                        strip.Tag = this;
                        mainForm.radCommandBar1.Rows[0].Strips.Add(strip);
                        strip.DesiredLocation = PointF.Empty;
                    }

                    row.Strips.Clear();
                }

            }

            this.radCommandBar1.Visible = false;
            this.radCommandBar1.CommandBarElement.InvalidateMeasure(true);
            mainForm.radCommandBar1.CommandBarElement.InvalidateMeasure(true);
        }

        void UnmergeCommandBars()
        {
            MainForm mainForm = this.MdiParent as MainForm;
            if (mainForm != null)
            {
                if (this.radCommandBar1.Rows.Count == 0)
                {
                    this.radCommandBar1.Rows.Add(new CommandBarRowElement());
                }

                foreach (CommandBarRowElement row in mainForm.radCommandBar1.Rows)
                {
                    List<CommandBarStripElement> toDelete = new List<CommandBarStripElement>();

                    foreach (CommandBarStripElement strip in row.Strips)
                    {
                        if (strip.Tag == this)
                        {
                            this.radCommandBar1.Rows[0].Strips.Add(strip);
                            strip.DesiredLocation = PointF.Empty;
                            toDelete.Add(strip);
                        }
                    }

                    foreach (CommandBarStripElement strip in toDelete)
                    {
                        row.Strips.Remove(strip);
                    }
                }
            }

            this.radCommandBar1.Visible = true;
            
            this.radCommandBar1.CommandBarElement.InvalidateMeasure(true);
            mainForm.radCommandBar1.CommandBarElement.InvalidateMeasure(true);

            mainForm.radCommandBar1.Invalidate();
            mainForm.radCommandBar1.PerformLayout();

        }
    }
}
